# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetSiteResult',
    'AwaitableGetSiteResult',
    'get_site',
    'get_site_output',
]

@pulumi.output_type
class GetSiteResult:
    """
    A collection of values returned by getSite.
    """
    def __init__(__self__, config=None, id=None, site_name=None):
        if config and not isinstance(config, str):
            raise TypeError("Expected argument 'config' to be a str")
        pulumi.set(__self__, "config", config)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if site_name and not isinstance(site_name, str):
            raise TypeError("Expected argument 'site_name' to be a str")
        pulumi.set(__self__, "site_name", site_name)

    @property
    @pulumi.getter
    def config(self) -> str:
        """
        The site config.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="siteName")
    def site_name(self) -> str:
        """
        The site whose config should be retrieved.
        """
        return pulumi.get(self, "site_name")


class AwaitableGetSiteResult(GetSiteResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSiteResult(
            config=self.config,
            id=self.id,
            site_name=self.site_name)


def get_site(site_name: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSiteResult:
    """
    Retrieves the JSON pull-site info for a given site.  This can then be updated and sebsequently fed into the Site resource.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_prismasdwan as prismasdwan

    site1 = prismasdwan.get_site(site_name="Site1")
    ```


    :param str site_name: The site whose config should be retrieved.
    """
    __args__ = dict()
    __args__['siteName'] = site_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('prismasdwan:index/getSite:getSite', __args__, opts=opts, typ=GetSiteResult).value

    return AwaitableGetSiteResult(
        config=pulumi.get(__ret__, 'config'),
        id=pulumi.get(__ret__, 'id'),
        site_name=pulumi.get(__ret__, 'site_name'))


@_utilities.lift_output_func(get_site)
def get_site_output(site_name: Optional[pulumi.Input[str]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSiteResult]:
    """
    Retrieves the JSON pull-site info for a given site.  This can then be updated and sebsequently fed into the Site resource.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_prismasdwan as prismasdwan

    site1 = prismasdwan.get_site(site_name="Site1")
    ```


    :param str site_name: The site whose config should be retrieved.
    """
    ...
